#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""

from xml.dom import minidom
import urllib
from classes import *
import config


class YahooWeb(Result):
    def __init__(self, name, url, summary, rating, language, real_url):
        Result.__init__(self, name, url)
        self.summary = summary
        self.rating = rating
        self.language = language
        self.real_url = real_url


class SearchYahooWeb(SearchModule):
	def __init__(self):
		SearchModule.__init__(self)

		
	def search(self, search_terms):
		source = 'http://boss.yahooapis.com/ysearch/web/v1/' + urllib.quote_plus(search_terms) + '?appid=' + config.yahoo_api + '&view=delicious_saves,language&format=xml'
		file = urllib.urlopen(source)

		XML = minidom.parse(file)
		listaFeed = XML.getElementsByTagName('result')
		resultList = []

		for n in range(0, len(listaFeed)):
			self.add(listaFeed, n)
			
		XML.unlink()

		return self.resultList
	

	def add(self, listaFeed, n):
		name = listaFeed[n].getElementsByTagName('title')[0].firstChild.data
		clickurl = listaFeed[n].getElementsByTagName('clickurl')[0].firstChild.data
		url = listaFeed[n].getElementsByTagName('url')[0].firstChild.data
		language = listaFeed[n].getElementsByTagName('language')[0].firstChild.data

		if( listaFeed[n].getElementsByTagName('abstract')[0].firstChild ):
			abstract = listaFeed[n].getElementsByTagName('abstract')[0].firstChild.data
		else:
			abstract = ''
			
		if( listaFeed[n].getElementsByTagName('delicious_saves')[0].firstChild ):
			delicious_saves = listaFeed[n].getElementsByTagName('delicious_saves')[0].firstChild.data
		else:
			delicious_saves = 0
			
		self.resultList.append(YahooWeb(name, clickurl, abstract, delicious_saves, language, url))
		


#~ s = SearchYahooWeb()
#~ s.search("molina")
#~ print unicode(s).encode("iso-8859-2", "replace")
